function setValue(cname, cvalue) {
    if (typeof exports !== 'undefined') {
        OrderCloud.Vars[cname] = cvalue;
    } else {
        document.cookie = cname + "=" + cvalue;
    }
}
function getValue(cname) {
    if (typeof exports !== 'undefined') {
        return OrderCloud.Vars[cname];
    } else {
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for(var i=0; i<ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0)==' ') c = c.substring(1);
            if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
        }
        return "";
    }

}

function deleteValue(cname) {
    if (typeof exports !== 'undefined') {
        OrderCloud.Vars[cname] = null;
    } else {
        document.cookie = cname + '=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
    }
}

OrderCloud.Auth = {
    impersonating: false,
    appname: OrderCloud.Vars.Appname ? OrderCloud.Vars.Appname : 'OrderCloud',
    GetToken: function() {
        if (typeof exports !== 'undefined') {
            return this.impersonating ? getValue('impersonationToken').Token : getValue('token');
        } else {
            return this.impersonating ? getValue(this.Appname + 'impersonating.token').Token : getValue(this.Appname + '.token');
        }
    },
    SetToken: function(token) {
        if (typeof exports !== 'undefined') {
            setValue('token', token);
        } else {
            setValue(this.Appname + '.token', token);
        }
    },
    RemoveToken: function() {
        if (typeof exports !== 'undefined') {
            deleteValue('token');
        }
        deleteValue(this.Appname + '.token');
    },
    IsAuthenticated: function() {
        var deferred = Q.defer();
        if (typeof exports !== 'undefined') {
            if (getValue('token')) {
                deferred.resolve(getValue('token'));
            } else {
                deferred.reject();
            }
        } else {
            if (getValue(this.Appname + '.token')) {
                deferred.resolve(getValue(this.Appname + '.token'));
            } else {
                deferred.reject();
            }
        }

        return deferred.promise;
    },
    SetImpersonationToken: function(userID, token) {
        var tokenObject = {
            UserID: userID,
            Token: token
        };
        typeof exports !== 'undefined' ? setValue('impersonationToken', tokenObject) : setValue(this.Appname + 'impersonating.token', tokenObject);
    },
    ClearImpersonationToken: function() {
        typeof exports !== 'undefined' ? deleteValue('impersonationToken') : deleteValue(this.Appname + 'impersonating.token');
    },
    IsImpersonating: function() {
        return this.impersonating;
    },
    SetImpersonating: function(bool) {
        this.impersonating = bool;
    },
    GetImpersonating: function() {
        return typeof exports !== 'undefined' ? getValue('impersonationToken') : getValue(this.Appname + 'impersonating.token');
    },
    Impersonate: function(userID, token) {
        if (token && userID) this.SetImpersonationToken(userID, token);
        this.impersonating = true;
    }
};